#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>

#define FIFO1 "/tmp/fifo.1"
#define FIFO2 "/tmp/fifo.2"

int main() {
	int N;
	mode_t fifo_flg = S_IRUSR | S_IWUSR;
	int readfd, writefd;
	char dit[10];
	char lit[10];

	/* creation du couple de fifos */
	if ((mkfifo(FIFO1,fifo_flg)<0 ) && (errno !=EEXIST)) {
		perror("mkfifo");
		exit(EXIT_FAILURE);
	} 
	printf("creation FIFO1 ok \n");

	if ((mkfifo(FIFO2,fifo_flg)<0 ) && (errno !=EEXIST)) { 
		perror("mkfifo");
		exit(EXIT_FAILURE);
	} 
	printf("creation FIFO2 ok \n");

	/* ouverture des fifos */
	if (((	writefd=open(FIFO2,O_WRONLY,0))<0) ||
		((readfd=open(FIFO1,O_RDONLY,0))<0)) {
		perror("open");
		if (unlink(FIFO1)<0) perror("unlink");
		if (unlink(FIFO2)<0) perror("unlink");
		exit(EXIT_FAILURE);
	}
	
	printf("FI ok\n");

	for (N=1;N<=5;N++) {
		sprintf(dit,"%d",N);
		write(writefd,dit,strlen(dit)+1);
		read(readfd,lit,11);
		printf("%s\n",lit);
	}

	close(readfd);
	close(writefd);

	if (unlink(FIFO1)<0) perror("unlink");
	if (unlink(FIFO2)<0) perror("unlink");

	exit(EXIT_SUCCESS);
}

