#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <unistd.h>
#include <signal.h>

#define FIFO "/tmp/fifo.server"

int stop=0;

void catch_int(){
	stop++;
	return;
}

int main() {
	int n,pid;
	mode_t fifo_flg = S_IRUSR | S_IWUSR;
	int serv_lit, clie_lit;

	int MAX=25;
	int LongLigneMax=22;	/* longueur max d'une ligne ecrite dans la FIFO */
	char buf[MAX],str[MAX],lu[MAX];
	int i;
	char *pos;
	char FIFO_cli[20];

	/* creation de la fifo */
	if ((mkfifo(FIFO,fifo_flg)<0 ) && (errno !=EEXIST)) {
		perror("mkfifo");
		exit(EXIT_FAILURE);
	} 

	/* ouverture des fifos */

	if ((serv_lit=open(FIFO,O_RDONLY,0))<0 ) {
		perror("open");
		if (unlink(FIFO)<0) perror("unlink");
		exit(EXIT_FAILURE);
	}

	printf("creation et ouverture /tmp/fifo.server ok \n");
	
	signal(SIGINT,catch_int);

	for (;stop==0;) {
		n=read(serv_lit,buf,MAX-LongLigneMax);
		buf[n]='\0';

		for (i=1;(n>0 && buf[n-1]!='!' && i<=LongLigneMax);i++) {
			read(serv_lit,buf+(n++),1);
		}
		buf[n]='\0';
		
		pos=buf;
		while (strlen(pos)>0) {
			if (sscanf(pos,"%d,%[^!]!",&pid,str)!=2) exit(EXIT_FAILURE);
			printf(">%d< et >%s<\n",pid,str);
			sprintf(lu,"%d,%s!",pid,str);
			pos+=strlen(lu);

			sprintf(FIFO_cli,"/tmp/fifo.%d",pid);
			if ((clie_lit=open(FIFO_cli,O_WRONLY,0))<0 ) perror("open");
			else {
				write(clie_lit,str,1);
				close(clie_lit);
			}
		}
	}
	

	if (unlink(FIFO)<0) perror("unlink");

	exit(EXIT_SUCCESS);
}

