#include <stdio.h> 	/* pour printf 					*/
#include <stdlib.h> 	/* pour exit 					*/
#include <unistd.h> 	/* pour fork, pipe, getpid, read, write, sleep, */
			/*      close, getppid				*/
#include <sys/types.h>	/* pour fork, getpid, read, wait, getppid	*/
#include <sys/wait.h>	/* pour wait					*/
#include <errno.h>	/* pour perror 					*/
#include <string.h>	/* pour strlen					*/

int main(){ 
	int pid ; 
	int status=0;
	int fd[2];
	int Max=100;
	char buf[Max];
	int n;

	pipe(fd); 		/* Ouverture du tube. fd[0] est en lecture seule
				   et fd[1] en ecriture.*/

	pid = fork() ; 		/* Creation de la copie du processus courant */

	if (pid < 0) { 		/* Si fork() a echoue */
		perror("fork");
		exit(EXIT_FAILURE);
	} 
	
	printf("%5d > J'ai le pid %d. Mon pere a le pid %d\n",getpid(),getpid(),getppid()); 

	if (pid == 0) { 	/* Si on est dans le processus fils ... */

		n=read(fd[0],buf,Max);
		printf("%5d > J'ai lu %d caracteres dans le tube.\n",getpid(),n);
		printf("%5d > J'entends mon pere dans le tube. Il dit : %s\n",getpid(),buf);
		write(fd[1],"Oui Pere!",strlen("Oui Pere!")*sizeof(char)+1); 
		printf("%5d > Je lui reponds dans le tube : Oui Pere!\n",getpid(),buf);
	}
	else{ 			/* Si on est dans le pere */

		write(fd[1],"Fiston? T'es la?",strlen("Fiston? T'es la?")*sizeof(char)+1);
		printf("%5d > J'appelle mon fils dans le tube : Fiston? T'es la?\n",getpid(),buf);
		wait(&status);
		n=read(fd[0],buf,Max);
		printf("%5d > J'ai lu %d caracteres dans le tube.\n",getpid(),n);
		printf("%5d > J'entends mon fils. Il dit : %s\n",getpid(),buf);
		
		close(fd[0]);	/* fermeture du pipe */
		close(fd[1]);
	} 
	exit(EXIT_SUCCESS);
}
