#include <stdio.h> 	/* pour printf 					*/
#include <stdlib.h> 	/* pour exit 					*/
#include <unistd.h> 	/* pour fork, pipe, getpid, read, write, sleep, */
			/*      close, getppid				*/
#include <sys/types.h>	/* pour fork, getpid, read, wait, getppid	*/
#include <sys/wait.h>	/* pour wait					*/
#include <errno.h>	/* pour perror 					*/

int main(){ 
	int pid; 
	int status=0;
	int pere_lit[2];
	int fils_lit[2];
	int Max=100;
	char buf[Max];
	int n, N=1;
	const int Nmax=10;

	pipe(pere_lit);		/* Ouverture des pipes. avec X[0] ouvert en lecture */
	pipe(fils_lit);		/* seule et X[1] en ecriture.*/

	if ((pid=fork()) < 0) { /* Creation de la copie du processus courant */
		perror("fork");
		exit(EXIT_FAILURE);
	} 
	
	if (pid == 0) { 	/* Si on est dans le processus fils ... */

		close(fils_lit[1]); 	/* fermeture des pipes inutiles */
		close(pere_lit[0]);	/* le fils n'ecrira pas dans... */

		for (;;) {
			n=read(fils_lit[0],buf,Max);
			sscanf(buf,"%d",&N);
			if (N>=Nmax) break;
			printf("Fils > %d\n",(++N));
			n=sprintf(buf,"%d",N);
			write(pere_lit[1],buf,n);
		}
	}
	else { 			/* Si on est dans le pere */

		close(pere_lit[1]);	/* fermeture des pipes inutiles */
		close(fils_lit[0]);	

		printf("Pere > %d\n",N);
		n=sprintf(buf,"%d",N);
		n=write(fils_lit[1],buf,n);
		
		for (;;) {
			n=read(pere_lit[0],buf,Max);
			sscanf(buf,"%d",&N);
			if (N>=Nmax) break;
			printf("Pere > %d\n",(++N));
			n=sprintf(buf,"%d",N);
			write(fils_lit[1],buf,n);
		}
		
		close(pere_lit[0]);	/* fermeture des pipes */
		close(fils_lit[1]);
		wait(&status);
	} 
	exit(EXIT_SUCCESS);
}
