#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

int stop=0;

void catch_int() { stop++;}

int main(){
	int semid,pid=getpid();
	key_t clef;
	int semflg_ini= IPC_CREAT | 0600 ;	/* option de creation  du   tableau */
	int semflg_fin= IPC_RMID;		/* option de destruction du tableau */
	int nsems=1;				/* nombre de semaphores du  tableau */
	int creator=0;
	struct sembuf operation[nsems];

	clef = ftok(getenv("HOME"),(char) 9); 	/* generation de ma clef de tableau de semaphores */

	if ((semid= semget(clef, nsems, semflg_ini | IPC_EXCL))>=0) {	/* generation du tableau reussie */
		if (semctl(semid,0,SETVAL,1)<0) perror("semctl");	/* initialisation individuelle */
		printf("%5d > ok pour la creation du tableau de semaphore %d.\n",pid,semid);
		creator++;
	} else {				/* simple ouverture du tableau */
		if ((semid = semget(clef, nsems, semflg_ini))<=0) {
			perror("semget");
			exit(EXIT_FAILURE);
		}
		printf("%5d > ok pour l'ouverture du tableau de semaphore %d.\n",pid,semid);
	}
	
	signal(SIGINT,catch_int);

	/* preparation du tableau d'operations */
	operation[0].sem_num= 0;
	operation[0].sem_flg= 0;

	for (;stop==0;) {
		printf("%5d avant sa region critique\n",pid);

		operation[0].sem_op = -1;
		/* application du tableau d'operation */
		if (semop(semid,operation,1)!=0) {
			perror("semop");
			exit(EXIT_FAILURE);
		}	
		printf("%5d >> region critique",pid);
		sleep(1);
		printf(" << %5d\n",pid);
		operation[0].sem_op = 1;
		if (semop(semid,operation,1)!=0) {
			perror("semop");
			exit(EXIT_FAILURE);
		}

		printf("%5d apres sa region critique\n",pid);
		sleep(1);
	}

	printf("%5d prend fin\n",pid);

	if (creator!=0) { 	/* le process a cree le tableau */
		if ((semctl(semid,5,semflg_fin,NULL))<0) {	/* suppression du tableau de semaphores */
			perror("msgctl");
			exit(EXIT_FAILURE);
		} 
	}

	exit(EXIT_SUCCESS);
}
