#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

int main(){
	int semid;
	key_t clef;
	int semflg_ini= IPC_CREAT | 0600 ;	/* option de creation  du   tableau */
	int semflg_fin= IPC_RMID;		/* option de destruction du tableau */
	int nsems=2;				/* nombre de semaphores du  tableau */
	int i;
	ushort array[nsems];
	ushort array2[nsems];
	struct sembuf operation[nsems];

	clef = ftok(getenv("HOME"),(char) 4); 	/* generation de ma clef de file de message */
	if ((semid = semget(clef, nsems, semflg_ini))<0) { /* generation de la file */
		perror("semget");
		exit(EXIT_FAILURE);
	}
	else printf("%d > ok pour la creation du tableaux de semaphores %d.\n",getpid(),semid);


	if (semctl(semid,0,SETVAL,1)<0) perror("semctl");     /* initialisations individuelles */
	if (semctl(semid,1,SETVAL,10)<0) perror("semctl");    /* des  valeurs  des  semaphores */
	
	for (i=0;i<nsems;i++) {printf("sem(%d) a la valeur %d\n",i,semctl(semid,i,GETVAL,NULL));} 

	for (i=0;i<nsems;i++) {array[i]=5+i;}
	if (semctl(semid,0,SETALL,&array)<0) perror("semctl"); /* initialisation globale */

	/* lectures individuelles des valeurs des semaphores */
	for (i=0;i<nsems;i++) {printf("sem(%d) a la valeur %d\n",i,semctl(semid,i,GETVAL,NULL));} 

	/* lecture globale des valeurs des semaphores */
	semctl(semid,0,GETALL,&array2);
	for (i=0;i<nsems;i++) {printf("sem(%d) a la valeur %d\n",i,array2[i]);} 

	/* preparation du tableau d'operations */
	operation[0].sem_num= 0;
	operation[0].sem_op = 1;
	operation[0].sem_flg= 0;
	operation[1].sem_num= 1;
	operation[1].sem_op = 2;
	operation[1].sem_flg= 0;

	/* application du tableau d'operation */
	if (semop(semid,operation,2)!=0) perror("semop");

	/* lectures individuelles des valeurs des semaphores */
	for (i=0;i<nsems;i++) {printf("sem(%d) a la valeur %d\n",i,semctl(semid,i,GETVAL,NULL));} 

	/* modification du tableau d'operations */
	operation[0].sem_num= 1;
	operation[0].sem_op =-8;
	operation[0].sem_flg= 0;

	/* application du tableau d'operation */
	if (semop(semid,operation,1)!=0) perror("semop");

	/* lectures individuelles des valeurs des semaphores */
	for (i=0;i<nsems;i++) {printf("sem(%d) a la valeur %d\n",i,semctl(semid,i,GETVAL,NULL));} 

	if ((semctl(semid,5,IPC_RMID,NULL))<0) {/* suppression du tableau de semaphores */
		perror("msgctl");}

	exit(EXIT_SUCCESS);
}
