#include <stdio.h>
#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/ipc.h>
#include <sys/sem.h>

int stop=0;

void catch_int() { stop++;}

int main(){
	int semid,pid=getpid(),status;
	key_t clef;
	int semflg_ini= IPC_CREAT | 0600 ;	/* option de creation  du   tableau */
	int semflg_fin= IPC_RMID;		/* option de destruction du tableau */
	int nsems=3;				/* nombre de semaphores du  tableau */
	const int MUTEX=0,EMPTY=1,FULL=2;	/* serviront d'indices */
	ushort val_set[nsems];			/* servira a fixer les valeurs des sem */
	struct sembuf operation[nsems];
	const int Nob=10;
	int n,nMAX,cons,prod;
	


	clef = ftok(getenv("HOME"),(char) 19); 	/* generation de ma clef de tableau de semaphores */

	if ((semid= semget(clef, nsems, semflg_ini | IPC_EXCL))>=0) {	/* generation du tableau reussie */
		val_set[MUTEX]=1;
		val_set[EMPTY]=Nob;
		val_set[FULL]=0;
		if (semctl(semid,0,SETALL,&val_set)<0) perror("semctl");	/* initialisation */
		printf("%5d > ok pour la creation du tableau de semaphores %d.\n",pid,semid);
	} else {
		perror("semget");
		exit(EXIT_FAILURE);
	}
	
	signal(SIGINT,catch_int);

	if ((pid=fork())==0) { 	/* le fils */
		for (;stop==0;) {
			operation[0].sem_num =  FULL;
			operation[0].sem_flg =  0;
			operation[0].sem_op  = -1;
			operation[1].sem_num =  MUTEX ;
			operation[1].sem_flg =  0;
			operation[1].sem_op  = -1;

			if (semop(semid,operation,2)!=0) perror("semop");	/* entree dans la section critique */

			if ( cons==0) {						/* si la consommation etait arretee */
				printf("Consommation relancee\n");
				cons++;
			}

			printf("Je consomme le %2d-e objet\n",semctl(semid,FULL,GETVAL,0)+1);

			if (semctl(semid,FULL,GETVAL,0)==0) {			/* si la consommation devient imposs */
				printf("Consommation impossible\n");
				cons=0;
			} 

			operation[0].sem_num =  MUTEX;
			operation[0].sem_flg =  0;
			operation[0].sem_op  =  1;
			operation[1].sem_num =  EMPTY;
			operation[1].sem_flg =  0;
			operation[1].sem_op  =  1;

			if (semop(semid,operation,2)!=0) perror("semop");

			nMAX=rand()/5;n=0;while (n++<nMAX);;
		}

		if (kill(getppid(),SIGINT)!=0) { /* envoi de SIGKILL au fils */
			perror("kill");
			exit(EXIT_FAILURE);
		}
		exit(EXIT_SUCCESS);

	} else { 		/* le pere */
		for (;stop==0;) {
			operation[0].sem_num =  EMPTY;
			operation[0].sem_flg =  0;
			operation[0].sem_op  = -1;
			operation[1].sem_num =  MUTEX ;
			operation[1].sem_flg =  0;
			operation[1].sem_op  = -1;

			if (semop(semid,operation,2)!=0) perror("semop");	/* entree dans la section critique */

			if (prod==0) {						/* si la prod etait bloquee */
				printf("Production relancee\n");
				prod++;
			}

			printf("Je produit le %2d-e objet\n",semctl(semid,FULL,GETVAL,0)+1);

			if (semctl(semid,EMPTY,GETVAL,0)==0) {			/* si la prod devient impossible */
				printf("Production impossible\n");
				prod=0;
			} 

			operation[0].sem_num =  MUTEX;
			operation[0].sem_flg =  0;
			operation[0].sem_op  =  1;
			operation[1].sem_num =  FULL;
			operation[1].sem_flg =  0;
			operation[1].sem_op  =  1;
			
			if (semop(semid,operation,2)!=0) perror("semop");	/* sortie dans la section critique */

			nMAX=rand()/8;n=0;while (n++<nMAX);;
		}

		if (kill(pid,SIGINT)!=0) { /* envoi de SIGKILL au fils */
			perror("kill");
			exit(EXIT_FAILURE);
		}
		wait(&status);
		if ((semctl(semid,5,semflg_fin,NULL))<0) {      /* suppression du tableau de semaphores */
			perror("msgctl");
			exit(EXIT_FAILURE);
		} 

		exit(EXIT_SUCCESS);
	}
}
